<template>
  <div class="app-container">

      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="大型车提成比例" prop="rescueTcBig">
          <el-input v-model="form.rescueTcBig" placeholder="请输入救援大拖车提成比例" />
        </el-form-item>
        <el-form-item label="中型车提成比例" prop="rescueTcMid">
          <el-input v-model="form.rescueTcMid" placeholder="请输入救援中型车提成比例" />
        </el-form-item>
        <el-form-item label="小型车提成比例" prop="rescueTcSmall">
          <el-input v-model="form.rescueTcSmall" placeholder="请输入救援小拖车提成比例" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
  </div>
</template>

<script>
import {  getRescueConfig, addRescueConfig, updateRescueConfig } from "./api/rescueConfig";

export default {
  name: "RescueConfig",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 救援司机提成配置表格数据
      rescueConfigList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        topDeptId: null,
        rescueTcBig: null,
        rescueTcMid: null,
        rescueTcSmall: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getInfo();
  },
  methods: {
    /** 查询救援司机提成配置列表 */
    getInfo() {
      this.loading = true;
      getRescueConfig().then(response => {
        this.form = response.data;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        topDeptId: null,
        rescueTcBig: null,
        rescueTcMid: null,
        rescueTcSmall: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加救援司机提成配置";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getRescueConfig(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改救援司机提成配置";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateRescueConfig(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRescueConfig(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除救援司机提成配置编号为"' + ids + '"的数据项？').then(function() {
        return delRescueConfig(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('rescue/rescueConfig/export', {
        ...this.queryParams
      }, `rescueConfig_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
